from django.utils.decorators import method_decorator
from django.views.generic import DetailView

from core.custom_annotations import group_required
from core.models import Submission


class SubmissionView(DetailView):

    template_name = 'core/submission_view.html'
    model = Submission

    @method_decorator(group_required('Reviewers', 'Students'))
    def dispatch(self, *args, **kwargs):
        return super(SubmissionView, self).dispatch(*args, **kwargs)

    def get_object(self):
        obj = Submission.objects.get(slug=self.kwargs['slug'])
        if obj.final_feedback is not None:
            obj.seen = True
            obj.save()
        return obj
